/* Autogenerated. */
%{
#include "parser.h"

#include <gont/runtime.h>

#define YYERROR_VERBOSE 1
#define YYDEBUG 1

/* Defined in support.c. */
struct GontS_Ast__location *make_location(YYLTYPE *l);
void yyerror(const char *msg);

extern YYLTYPE last_lex_loc;

void *gyy__retval;

%}



/* Terminals. */

%token INT "integer literal"
%token FLOAT "float literal"
%token ID "identifier"
%token STRING "string literal"
%token TYVAR "type variable"
%token CHAR "character literal"
%token LEX_ERROR "lexical error"
%token KW_AS "as"
%token KW_BOOL "bool"
%token KW_BREAK "break"
%token KW_CASE "case"
%token KW_CLASS "class"
%token KW_CONTINUE "continue"
%token KW_DEF "def"
%token KW_DO "do"
%token KW_ELSE "else"
%token KW_EXCEPTION "exception"
%token KW_EXTERN "extern"
%token KW_FALSE "false"
%token KW_FINALLY "finally"
%token KW_FLOAT "float"
%token KW_FOR "for"
%token KW_FUN "fun"
%token KW_IF "if"
%token KW_IN "in"
%token KW_INT "int"
%token KW_LET "let"
%token KW_NAMESPACE "namespace"
%token KW_NEW "new"
%token KW_NULL "null"
%token KW_OBJECT "object"
%token KW_OPEN "open"
%token KW_OPT_STRUCT "opt_struct"
%token KW_PRIVATE "private"
%token KW_PROTECTED "protected"
%token KW_RAISE "raise"
%token KW_RETURN "return"
%token KW_SECTION "section"
%token KW_SKIP "skip"
%token KW_STRING "string"
%token KW_STRUCT "struct"
%token KW_SWITCH "switch"
%token KW_THIS "this"
%token KW_TRUE "true"
%token KW_TRY "try"
%token KW_TYPE "type"
%token KW_TYPEDEF "typedef"
%token KW_UNION "union"
%token KW_VIRTUAL "virtual"
%token KW_VOID "void"
%token KW_WHILE "while"
%token KW_WITH "with"
%token AND_AND "&&"
%token OR_OR "||"
%token ARROW "->"
%token GTGT ">>"
%token LTLT "<<"
%token DOUBLECOLON "::"
%token EQ "=="
%token NE "!="
%token GE ">="
%token LE "<="
%token MINUS_EQUAL "-="
%token PERCENT_EQUAL "%="
%token PLUS_EQUAL "+="
%token SLASH_EQUAL "/="
%token STAR_EQUAL "*="
%token AND_EQUAL "&="
%token OR_EQUAL "|="
%token XOR_EQUAL "^="
%token LTLT_EQUAL "<<="
%token GTGT_EQUAL ">>="
%token MINUS_MINUS "--"
%token PLUS_PLUS "++"

/* End of terminals. */

%start gyacc_start

/* lowest precedence */
%left ','
%right '=' MINUS_EQUAL PERCENT_EQUAL PLUS_EQUAL SLASH_EQUAL STAR_EQUAL AND_EQUAL OR_EQUAL XOR_EQUAL LTLT_EQUAL GTGT_EQUAL
%left KW_WITH
%left OR_OR
%left AND_AND
%left '|'
%left '^'
%left '&'
%left EQ NE
%left '<' '>' GE LE
%left LTLT GTGT
%left '+' '-'
%left '*' '%' '/'
%nonassoc UMINUS
%right PLUS_PLUS MINUS_MINUS '!'
%left '.' '('
/* highest precedence */

%expect 1


%%
gyacc_start: module
	{ gyy__retval = $1; };

nl_decl:
	  type_decl
		{
			extern void *gyy_nl_decl___0(void*, void*);
			$$ = gyy_nl_decl___0(make_location(&@$), $1);
		}
	| KW_EXCEPTION vardef ';'
		{
			extern void *gyy_nl_decl___1(void*, void*);
			$$ = gyy_nl_decl___1(make_location(&@$), $2);
		}
	| func_header ';'
		{
			extern void *gyy_nl_decl___2(void*, void*);
			$$ = gyy_nl_decl___2(make_location(&@$), $1);
		}
	| func_header '=' string ';'
		{
			extern void *gyy_nl_decl___3(void*, void*, void*);
			$$ = gyy_nl_decl___3(make_location(&@$), $1, $3);
		}
	| KW_OPEN ID ';'
		{
			extern void *gyy_nl_decl___4(void*, void*);
			$$ = gyy_nl_decl___4(make_location(&@$), $2);
		}
	| KW_EXTERN func_header maybe_eq ';'
		{
			extern void *gyy_nl_decl___5(void*, void*, void*);
			$$ = gyy_nl_decl___5(make_location(&@$), $2, $3);
		}
	| KW_EXTERN vardef maybe_eq ';'
		{
			extern void *gyy_nl_decl___6(void*, void*, void*);
			$$ = gyy_nl_decl___6(make_location(&@$), $2, $3);
		}
	| KW_SECTION ID lambda_body
		{
			extern void *gyy_nl_decl___7(void*, void*, void*);
			$$ = gyy_nl_decl___7(make_location(&@$), $2, $3);
		}
	| func_header maybe_export_as lambda_body
		{
			extern void *gyy_nl_decl___8(void*, void*, void*, void*);
			$$ = gyy_nl_decl___8(make_location(&@$), $1, $2, $3);
		}
;

decl:
	  nl_decl
		{
			extern void *gyy_decl___0(void*, void*);
			$$ = gyy_decl___0(make_location(&@$), $1);
		}
;

decls:
	  decl decls
		{
			extern void *gyy_decls___0(void*, void*, void*);
			$$ = gyy_decls___0(make_location(&@$), $1, $2);
		}
	| multi_decl decls
		{
			extern void *gyy_decls___1(void*, void*, void*);
			$$ = gyy_decls___1(make_location(&@$), $1, $2);
		}
	| 
		{
			extern void *gyy_decls___2(void*);
			$$ = gyy_decls___2(make_location(&last_lex_loc));
		}
	| error decls
		{
			extern void *gyy_decls___3(void*, void*);
			$$ = gyy_decls___3(make_location(&@$), $2);
		}
;

multi_decl:
	  ';'
		{
			extern void *gyy_multi_decl___0(void*);
			$$ = gyy_multi_decl___0(make_location(&@$));
		}
	| global_var_def ';'
		{
			extern void *gyy_multi_decl___1(void*, void*);
			$$ = gyy_multi_decl___1(make_location(&@$), $1);
		}
;

module:
	  decls
		{
			extern void *gyy_module___0(void*, void*);
			$$ = gyy_module___0(make_location(&@$), $1);
		}
;

maybe_eq:
	  '=' string
		{
			extern void *gyy_maybe_eq___0(void*, void*);
			$$ = gyy_maybe_eq___0(make_location(&@$), $2);
		}
	| 
		{
			extern void *gyy_maybe_eq___1(void*);
			$$ = gyy_maybe_eq___1(make_location(&last_lex_loc));
		}
;

string:
	  STRING
		{
			extern void *gyy_string___0(void*, void*);
			$$ = gyy_string___0(make_location(&@$), $1);
		}
	| STRING string
		{
			extern void *gyy_string___1(void*, void*, void*);
			$$ = gyy_string___1(make_location(&@$), $1, $2);
		}
;

maybe_export_as:
	  
		{
			extern void *gyy_maybe_export_as___0(void*);
			$$ = gyy_maybe_export_as___0(make_location(&last_lex_loc));
		}
	| KW_EXTERN string
		{
			extern void *gyy_maybe_export_as___1(void*, void*);
			$$ = gyy_maybe_export_as___1(make_location(&@$), $2);
		}
;

id:
	  ID
		{
			extern void *gyy_id___0(void*, void*);
			$$ = gyy_id___0(make_location(&@$), $1);
		}
;

qid:
	  id
		{
			extern void *gyy_qid___0(void*, void*);
			$$ = gyy_qid___0(make_location(&@$), $1);
		}
	| ID DOUBLECOLON ID
		{
			extern void *gyy_qid___1(void*, void*, void*);
			$$ = gyy_qid___1(make_location(&@$), $1, $3);
		}
;

sid:
	  ID
		{
			extern void *gyy_sid___0(void*, void*);
			$$ = gyy_sid___0(make_location(&@$), $1);
		}
	| ID DOUBLECOLON ID
		{
			extern void *gyy_sid___1(void*, void*, void*);
			$$ = gyy_sid___1(make_location(&@$), $1, $3);
		}
;

tid:
	  ID
		{
			extern void *gyy_tid___0(void*, void*);
			$$ = gyy_tid___0(make_location(&@$), $1);
		}
	| ID DOUBLECOLON ID
		{
			extern void *gyy_tid___1(void*, void*, void*);
			$$ = gyy_tid___1(make_location(&@$), $1, $3);
		}
;

vardef:
	  type_expr id
		{
			extern void *gyy_vardef___0(void*, void*, void*);
			$$ = gyy_vardef___0(make_location(&@$), $1, $2);
		}
;

ne_type_var_list_content:
	  TYVAR ',' ne_type_var_list_content
		{
			extern void *gyy_ne_type_var_list_content___0(void*, void*, void*);
			$$ = gyy_ne_type_var_list_content___0(make_location(&@$), $1, $3);
		}
	| TYVAR
		{
			extern void *gyy_ne_type_var_list_content___1(void*, void*);
			$$ = gyy_ne_type_var_list_content___1(make_location(&@$), $1);
		}
;

type_var_list_content:
	  
		{
			extern void *gyy_type_var_list_content___0(void*);
			$$ = gyy_type_var_list_content___0(make_location(&last_lex_loc));
		}
	| ne_type_var_list_content
		{
			extern void *gyy_type_var_list_content___1(void*, void*);
			$$ = gyy_type_var_list_content___1(make_location(&@$), $1);
		}
;

type_var_list:
	  
		{
			extern void *gyy_type_var_list___0(void*);
			$$ = gyy_type_var_list___0(make_location(&last_lex_loc));
		}
	| '<' type_var_list_content '>'
		{
			extern void *gyy_type_var_list___1(void*, void*);
			$$ = gyy_type_var_list___1(make_location(&@$), $2);
		}
;

sid_lst:
	  sid ',' sid_lst
		{
			extern void *gyy_sid_lst___0(void*, void*, void*);
			$$ = gyy_sid_lst___0(make_location(&@$), $1, $3);
		}
	| sid
		{
			extern void *gyy_sid_lst___1(void*, void*);
			$$ = gyy_sid_lst___1(make_location(&@$), $1);
		}
;

struct_flds_1:
	  type_expr sid_lst ';'
		{
			extern void *gyy_struct_flds_1___0(void*, void*, void*);
			$$ = gyy_struct_flds_1___0(make_location(&@$), $1, $2);
		}
;

struct_flds:
	  struct_flds_1
		{
			extern void *gyy_struct_flds___0(void*, void*);
			$$ = gyy_struct_flds___0(make_location(&@$), $1);
		}
	| struct_flds_1 struct_flds
		{
			extern void *gyy_struct_flds___1(void*, void*, void*);
			$$ = gyy_struct_flds___1(make_location(&@$), $1, $2);
		}
;

qid_lst:
	  qid ',' qid_lst
		{
			extern void *gyy_qid_lst___0(void*, void*, void*);
			$$ = gyy_qid_lst___0(make_location(&@$), $1, $3);
		}
	| qid
		{
			extern void *gyy_qid_lst___1(void*, void*);
			$$ = gyy_qid_lst___1(make_location(&@$), $1);
		}
;

union_flds_1:
	  type_expr qid_lst ';'
		{
			extern void *gyy_union_flds_1___0(void*, void*, void*);
			$$ = gyy_union_flds_1___0(make_location(&@$), $1, $2);
		}
;

union_flds:
	  union_flds_1
		{
			extern void *gyy_union_flds___0(void*, void*);
			$$ = gyy_union_flds___0(make_location(&@$), $1);
		}
	| union_flds_1 union_flds
		{
			extern void *gyy_union_flds___1(void*, void*, void*);
			$$ = gyy_union_flds___1(make_location(&@$), $1, $2);
		}
;

type_decl:
	  KW_STRUCT type_var_list ID '{' struct_flds '}'
		{
			extern void *gyy_type_decl___0(void*, void*, void*, void*);
			$$ = gyy_type_decl___0(make_location(&@$), $2, $3, $5);
		}
	| KW_OPT_STRUCT type_var_list ID '{' struct_flds '}'
		{
			extern void *gyy_type_decl___1(void*, void*, void*, void*);
			$$ = gyy_type_decl___1(make_location(&@$), $2, $3, $5);
		}
	| KW_UNION type_var_list ID '{' union_flds '}'
		{
			extern void *gyy_type_decl___2(void*, void*, void*, void*);
			$$ = gyy_type_decl___2(make_location(&@$), $2, $3, $5);
		}
	| KW_TYPEDEF type_expr type_var_list ID ';'
		{
			extern void *gyy_type_decl___3(void*, void*, void*, void*);
			$$ = gyy_type_decl___3(make_location(&@$), $2, $3, $4);
		}
	| KW_TYPE type_var_list ID ';'
		{
			extern void *gyy_type_decl___4(void*, void*, void*);
			$$ = gyy_type_decl___4(make_location(&@$), $2, $3);
		}
;

simple_type:
	  KW_VOID
		{
			extern void *gyy_simple_type___0(void*);
			$$ = gyy_simple_type___0(make_location(&@$));
		}
	| KW_INT
		{
			extern void *gyy_simple_type___1(void*);
			$$ = gyy_simple_type___1(make_location(&@$));
		}
	| KW_BOOL
		{
			extern void *gyy_simple_type___2(void*);
			$$ = gyy_simple_type___2(make_location(&@$));
		}
	| KW_FLOAT
		{
			extern void *gyy_simple_type___3(void*);
			$$ = gyy_simple_type___3(make_location(&@$));
		}
	| KW_STRING
		{
			extern void *gyy_simple_type___4(void*);
			$$ = gyy_simple_type___4(make_location(&@$));
		}
;

function_type_content:
	  type_expr '(' func_args ')'
		{
			extern void *gyy_function_type_content___0(void*, void*, void*);
			$$ = gyy_function_type_content___0(make_location(&@$), $1, $3);
		}
;

function_type:
	  '*' function_type_content
		{
			extern void *gyy_function_type___0(void*, void*);
			$$ = gyy_function_type___0(make_location(&@$), $2);
		}
	| '*' '(' function_type_content ')'
		{
			extern void *gyy_function_type___1(void*, void*);
			$$ = gyy_function_type___1(make_location(&@$), $3);
		}
;

named_type:
	  '<' ty_list '>' tid
		{
			extern void *gyy_named_type___0(void*, void*, void*);
			$$ = gyy_named_type___0(make_location(&@$), $2, $4);
		}
	| LTLT ne_ty_list '>' tid '>' tid
		{
			extern void *gyy_named_type___1(void*, void*, void*, void*);
			$$ = gyy_named_type___1(make_location(&@$), $2, $4, $6);
		}
	| LTLT ne_ty_list '>' tid ',' ne_ty_list '>' tid
		{
			extern void *gyy_named_type___2(void*, void*, void*, void*, void*);
			$$ = gyy_named_type___2(make_location(&@$), $2, $4, $6, $8);
		}
;

xtype_expr:
	  simple_type
		{
			extern void *gyy_xtype_expr___0(void*, void*);
			$$ = gyy_xtype_expr___0(make_location(&@$), $1);
		}
	| function_type
		{
			extern void *gyy_xtype_expr___1(void*, void*);
			$$ = gyy_xtype_expr___1(make_location(&@$), $1);
		}
	| TYVAR
		{
			extern void *gyy_xtype_expr___2(void*, void*);
			$$ = gyy_xtype_expr___2(make_location(&@$), $1);
		}
	| named_type
		{
			extern void *gyy_xtype_expr___3(void*, void*);
			$$ = gyy_xtype_expr___3(make_location(&@$), $1);
		}
	| '*' '(' tuple_ty_content ')'
		{
			extern void *gyy_xtype_expr___4(void*, void*);
			$$ = gyy_xtype_expr___4(make_location(&@$), $3);
		}
;

type_expr:
	  '(' xtype_expr ')'
		{
			extern void *gyy_type_expr___0(void*, void*);
			$$ = gyy_type_expr___0(make_location(&@$), $2);
		}
	| tid
		{
			extern void *gyy_type_expr___1(void*, void*);
			$$ = gyy_type_expr___1(make_location(&@$), $1);
		}
	| xtype_expr
		{
			extern void *gyy_type_expr___2(void*, void*);
			$$ = gyy_type_expr___2(make_location(&@$), $1);
		}
;

ne_ty_list:
	  type_expr ',' ne_ty_list
		{
			extern void *gyy_ne_ty_list___0(void*, void*, void*);
			$$ = gyy_ne_ty_list___0(make_location(&@$), $1, $3);
		}
	| type_expr
		{
			extern void *gyy_ne_ty_list___1(void*, void*);
			$$ = gyy_ne_ty_list___1(make_location(&@$), $1);
		}
;

ty_list:
	  
		{
			extern void *gyy_ty_list___0(void*);
			$$ = gyy_ty_list___0(make_location(&last_lex_loc));
		}
	| ne_ty_list
		{
			extern void *gyy_ty_list___1(void*, void*);
			$$ = gyy_ty_list___1(make_location(&@$), $1);
		}
;

tuple_ty_content:
	  type_expr ',' ne_ty_list
		{
			extern void *gyy_tuple_ty_content___0(void*, void*, void*);
			$$ = gyy_tuple_ty_content___0(make_location(&@$), $1, $3);
		}
;

maybe_name:
	  ID
		{
			extern void *gyy_maybe_name___0(void*, void*);
			$$ = gyy_maybe_name___0(make_location(&@$), $1);
		}
	| 
		{
			extern void *gyy_maybe_name___1(void*);
			$$ = gyy_maybe_name___1(make_location(&last_lex_loc));
		}
;

func_arg:
	  type_expr maybe_name
		{
			extern void *gyy_func_arg___0(void*, void*, void*);
			$$ = gyy_func_arg___0(make_location(&@$), $1, $2);
		}
	| '_' maybe_name
		{
			extern void *gyy_func_arg___1(void*, void*);
			$$ = gyy_func_arg___1(make_location(&@$), $2);
		}
;

ne_func_args:
	  func_arg ',' ne_func_args
		{
			extern void *gyy_ne_func_args___0(void*, void*, void*);
			$$ = gyy_ne_func_args___0(make_location(&@$), $1, $3);
		}
	| func_arg
		{
			extern void *gyy_ne_func_args___1(void*, void*);
			$$ = gyy_ne_func_args___1(make_location(&@$), $1);
		}
;

func_args:
	  
		{
			extern void *gyy_func_args___0(void*);
			$$ = gyy_func_args___0(make_location(&last_lex_loc));
		}
	| ne_func_args
		{
			extern void *gyy_func_args___1(void*, void*);
			$$ = gyy_func_args___1(make_location(&@$), $1);
		}
;

func_header:
	  type_expr id '(' func_args ')'
		{
			extern void *gyy_func_header___0(void*, void*, void*, void*);
			$$ = gyy_func_header___0(make_location(&@$), $1, $2, $4);
		}
	| '_' id '(' func_args ')'
		{
			extern void *gyy_func_header___1(void*, void*, void*);
			$$ = gyy_func_header___1(make_location(&@$), $2, $4);
		}
	| KW_DEF id '(' xt_args ')'
		{
			extern void *gyy_func_header___2(void*, void*, void*);
			$$ = gyy_func_header___2(make_location(&@$), $2, $4);
		}
;

xt_arg:
	  ID
		{
			extern void *gyy_xt_arg___0(void*, void*);
			$$ = gyy_xt_arg___0(make_location(&@$), $1);
		}
	| '_'
		{
			extern void *gyy_xt_arg___1(void*);
			$$ = gyy_xt_arg___1(make_location(&@$));
		}
;

ne_xt_args:
	  xt_arg ',' ne_xt_args
		{
			extern void *gyy_ne_xt_args___0(void*, void*, void*);
			$$ = gyy_ne_xt_args___0(make_location(&@$), $1, $3);
		}
	| xt_arg
		{
			extern void *gyy_ne_xt_args___1(void*, void*);
			$$ = gyy_ne_xt_args___1(make_location(&@$), $1);
		}
;

xt_args:
	  
		{
			extern void *gyy_xt_args___0(void*);
			$$ = gyy_xt_args___0(make_location(&last_lex_loc));
		}
	| ne_xt_args
		{
			extern void *gyy_xt_args___1(void*, void*);
			$$ = gyy_xt_args___1(make_location(&@$), $1);
		}
;

tuple_content:
	  xexpr ',' ne_xexpr_list
		{
			extern void *gyy_tuple_content___0(void*, void*, void*);
			$$ = gyy_tuple_content___0(make_location(&@$), $1, $3);
		}
;

tuple:
	  '(' tuple_content ')'
		{
			extern void *gyy_tuple___0(void*, void*);
			$$ = gyy_tuple___0(make_location(&@$), $2);
		}
;

struct_init:
	  sid '=' xexpr
		{
			extern void *gyy_struct_init___0(void*, void*, void*);
			$$ = gyy_struct_init___0(make_location(&@$), $1, $3);
		}
;

struct_expr_content:
	  struct_init ',' struct_expr_content
		{
			extern void *gyy_struct_expr_content___0(void*, void*, void*);
			$$ = gyy_struct_expr_content___0(make_location(&@$), $1, $3);
		}
	| struct_init
		{
			extern void *gyy_struct_expr_content___1(void*, void*);
			$$ = gyy_struct_expr_content___1(make_location(&@$), $1);
		}
;

struct_expr:
	  '{' struct_expr_content '}'
		{
			extern void *gyy_struct_expr___0(void*, void*);
			$$ = gyy_struct_expr___0(make_location(&@$), $2);
		}
;

struct_copy:
	  xexpr KW_WITH '{' struct_expr_content '}'
		{
			extern void *gyy_struct_copy___0(void*, void*, void*);
			$$ = gyy_struct_copy___0(make_location(&@$), $1, $4);
		}
	| xexpr KW_WITH '{' '}'
		{
			extern void *gyy_struct_copy___1(void*, void*);
			$$ = gyy_struct_copy___1(make_location(&@$), $1);
		}
;

list_expr:
	  '[' xexpr_list ']'
		{
			extern void *gyy_list_expr___0(void*, void*);
			$$ = gyy_list_expr___0(make_location(&@$), $2);
		}
;

xexpr:
	  struct_expr
		{
			extern void *gyy_xexpr___0(void*, void*);
			$$ = gyy_xexpr___0(make_location(&@$), $1);
		}
	| struct_copy
		{
			extern void *gyy_xexpr___1(void*, void*);
			$$ = gyy_xexpr___1(make_location(&@$), $1);
		}
	| list_expr
		{
			extern void *gyy_xexpr___2(void*, void*);
			$$ = gyy_xexpr___2(make_location(&@$), $1);
		}
	| expr %prec ','
		{
			extern void *gyy_xexpr___3(void*, void*);
			$$ = gyy_xexpr___3(make_location(&@$), $1);
		}
;

raw_expr:
	  expr '+' expr
		{
			extern void *gyy_raw_expr___0(void*, void*, void*);
			$$ = gyy_raw_expr___0(make_location(&@$), $1, $3);
		}
	| expr '-' expr
		{
			extern void *gyy_raw_expr___1(void*, void*, void*);
			$$ = gyy_raw_expr___1(make_location(&@$), $1, $3);
		}
	| expr '*' expr
		{
			extern void *gyy_raw_expr___2(void*, void*, void*);
			$$ = gyy_raw_expr___2(make_location(&@$), $1, $3);
		}
	| expr '/' expr
		{
			extern void *gyy_raw_expr___3(void*, void*, void*);
			$$ = gyy_raw_expr___3(make_location(&@$), $1, $3);
		}
	| expr '%' expr
		{
			extern void *gyy_raw_expr___4(void*, void*, void*);
			$$ = gyy_raw_expr___4(make_location(&@$), $1, $3);
		}
	| expr '<' expr
		{
			extern void *gyy_raw_expr___5(void*, void*, void*);
			$$ = gyy_raw_expr___5(make_location(&@$), $1, $3);
		}
	| expr '>' expr
		{
			extern void *gyy_raw_expr___6(void*, void*, void*);
			$$ = gyy_raw_expr___6(make_location(&@$), $1, $3);
		}
	| expr GE expr
		{
			extern void *gyy_raw_expr___7(void*, void*, void*);
			$$ = gyy_raw_expr___7(make_location(&@$), $1, $3);
		}
	| expr LE expr
		{
			extern void *gyy_raw_expr___8(void*, void*, void*);
			$$ = gyy_raw_expr___8(make_location(&@$), $1, $3);
		}
	| expr NE expr
		{
			extern void *gyy_raw_expr___9(void*, void*, void*);
			$$ = gyy_raw_expr___9(make_location(&@$), $1, $3);
		}
	| expr EQ expr
		{
			extern void *gyy_raw_expr___10(void*, void*, void*);
			$$ = gyy_raw_expr___10(make_location(&@$), $1, $3);
		}
	| expr AND_AND expr
		{
			extern void *gyy_raw_expr___11(void*, void*, void*);
			$$ = gyy_raw_expr___11(make_location(&@$), $1, $3);
		}
	| expr OR_OR expr
		{
			extern void *gyy_raw_expr___12(void*, void*, void*);
			$$ = gyy_raw_expr___12(make_location(&@$), $1, $3);
		}
	| expr LTLT expr
		{
			extern void *gyy_raw_expr___13(void*, void*, void*);
			$$ = gyy_raw_expr___13(make_location(&@$), $1, $3);
		}
	| expr GTGT expr
		{
			extern void *gyy_raw_expr___14(void*, void*, void*);
			$$ = gyy_raw_expr___14(make_location(&@$), $1, $3);
		}
	| expr '&' expr
		{
			extern void *gyy_raw_expr___15(void*, void*, void*);
			$$ = gyy_raw_expr___15(make_location(&@$), $1, $3);
		}
	| expr '^' expr
		{
			extern void *gyy_raw_expr___16(void*, void*, void*);
			$$ = gyy_raw_expr___16(make_location(&@$), $1, $3);
		}
	| expr '|' expr
		{
			extern void *gyy_raw_expr___17(void*, void*, void*);
			$$ = gyy_raw_expr___17(make_location(&@$), $1, $3);
		}
	| '-' expr %prec UMINUS
		{
			extern void *gyy_raw_expr___18(void*, void*);
			$$ = gyy_raw_expr___18(make_location(&@$), $2);
		}
	| '~' expr %prec UMINUS
		{
			extern void *gyy_raw_expr___19(void*, void*);
			$$ = gyy_raw_expr___19(make_location(&@$), $2);
		}
	| '!' expr
		{
			extern void *gyy_raw_expr___20(void*, void*);
			$$ = gyy_raw_expr___20(make_location(&@$), $2);
		}
	| MINUS_MINUS expr
		{
			extern void *gyy_raw_expr___21(void*, void*);
			$$ = gyy_raw_expr___21(make_location(&@$), $2);
		}
	| PLUS_PLUS expr
		{
			extern void *gyy_raw_expr___22(void*, void*);
			$$ = gyy_raw_expr___22(make_location(&@$), $2);
		}
	| expr MINUS_MINUS
		{
			extern void *gyy_raw_expr___23(void*, void*);
			$$ = gyy_raw_expr___23(make_location(&@$), $1);
		}
	| expr PLUS_PLUS
		{
			extern void *gyy_raw_expr___24(void*, void*);
			$$ = gyy_raw_expr___24(make_location(&@$), $1);
		}
	| assign_expr
		{
			extern void *gyy_raw_expr___25(void*, void*);
			$$ = gyy_raw_expr___25(make_location(&@$), $1);
		}
;

assign_expr:
	  expr '=' xexpr
		{
			extern void *gyy_assign_expr___0(void*, void*, void*);
			$$ = gyy_assign_expr___0(make_location(&@$), $1, $3);
		}
	| expr MINUS_EQUAL xexpr
		{
			extern void *gyy_assign_expr___1(void*, void*, void*);
			$$ = gyy_assign_expr___1(make_location(&@$), $1, $3);
		}
	| expr PLUS_EQUAL xexpr
		{
			extern void *gyy_assign_expr___2(void*, void*, void*);
			$$ = gyy_assign_expr___2(make_location(&@$), $1, $3);
		}
	| expr PERCENT_EQUAL xexpr
		{
			extern void *gyy_assign_expr___3(void*, void*, void*);
			$$ = gyy_assign_expr___3(make_location(&@$), $1, $3);
		}
	| expr SLASH_EQUAL xexpr
		{
			extern void *gyy_assign_expr___4(void*, void*, void*);
			$$ = gyy_assign_expr___4(make_location(&@$), $1, $3);
		}
	| expr STAR_EQUAL xexpr
		{
			extern void *gyy_assign_expr___5(void*, void*, void*);
			$$ = gyy_assign_expr___5(make_location(&@$), $1, $3);
		}
	| expr AND_EQUAL xexpr
		{
			extern void *gyy_assign_expr___6(void*, void*, void*);
			$$ = gyy_assign_expr___6(make_location(&@$), $1, $3);
		}
	| expr XOR_EQUAL xexpr
		{
			extern void *gyy_assign_expr___7(void*, void*, void*);
			$$ = gyy_assign_expr___7(make_location(&@$), $1, $3);
		}
	| expr OR_EQUAL xexpr
		{
			extern void *gyy_assign_expr___8(void*, void*, void*);
			$$ = gyy_assign_expr___8(make_location(&@$), $1, $3);
		}
	| expr LTLT_EQUAL xexpr
		{
			extern void *gyy_assign_expr___9(void*, void*, void*);
			$$ = gyy_assign_expr___9(make_location(&@$), $1, $3);
		}
	| expr GTGT_EQUAL xexpr
		{
			extern void *gyy_assign_expr___10(void*, void*, void*);
			$$ = gyy_assign_expr___10(make_location(&@$), $1, $3);
		}
;

expr:
	  tuple
		{
			extern void *gyy_expr___0(void*, void*);
			$$ = gyy_expr___0(make_location(&@$), $1);
		}
	| raw_expr
		{
			extern void *gyy_expr___1(void*, void*);
			$$ = gyy_expr___1(make_location(&@$), $1);
		}
	| primary
		{
			extern void *gyy_expr___2(void*, void*);
			$$ = gyy_expr___2(make_location(&@$), $1);
		}
;

ne_xexpr_list:
	  xexpr ',' ne_xexpr_list
		{
			extern void *gyy_ne_xexpr_list___0(void*, void*, void*);
			$$ = gyy_ne_xexpr_list___0(make_location(&@$), $1, $3);
		}
	| xexpr
		{
			extern void *gyy_ne_xexpr_list___1(void*, void*);
			$$ = gyy_ne_xexpr_list___1(make_location(&@$), $1);
		}
;

xexpr_list:
	  
		{
			extern void *gyy_xexpr_list___0(void*);
			$$ = gyy_xexpr_list___0(make_location(&last_lex_loc));
		}
	| ne_xexpr_list
		{
			extern void *gyy_xexpr_list___1(void*, void*);
			$$ = gyy_xexpr_list___1(make_location(&@$), $1);
		}
;

lambda:
	  KW_FUN type_expr '(' func_args ')' lambda_body
		{
			extern void *gyy_lambda___0(void*, void*, void*, void*);
			$$ = gyy_lambda___0(make_location(&@$), $2, $4, $6);
		}
	| KW_FUN '_' '(' func_args ')' lambda_body
		{
			extern void *gyy_lambda___1(void*, void*, void*);
			$$ = gyy_lambda___1(make_location(&@$), $4, $6);
		}
	| KW_FUN '(' xt_args ')' lambda_body
		{
			extern void *gyy_lambda___2(void*, void*, void*);
			$$ = gyy_lambda___2(make_location(&@$), $3, $5);
		}
;

raw_constant:
	  string
		{
			extern void *gyy_raw_constant___0(void*, void*);
			$$ = gyy_raw_constant___0(make_location(&@$), $1);
		}
	| KW_TRUE
		{
			extern void *gyy_raw_constant___1(void*);
			$$ = gyy_raw_constant___1(make_location(&@$));
		}
	| KW_FALSE
		{
			extern void *gyy_raw_constant___2(void*);
			$$ = gyy_raw_constant___2(make_location(&@$));
		}
	| KW_NULL
		{
			extern void *gyy_raw_constant___3(void*);
			$$ = gyy_raw_constant___3(make_location(&@$));
		}
;

constant:
	  INT
		{
			extern void *gyy_constant___0(void*, void*);
			$$ = gyy_constant___0(make_location(&@$), $1);
		}
	| FLOAT
		{
			extern void *gyy_constant___1(void*, void*);
			$$ = gyy_constant___1(make_location(&@$), $1);
		}
	| CHAR
		{
			extern void *gyy_constant___2(void*, void*);
			$$ = gyy_constant___2(make_location(&@$), $1);
		}
	| raw_constant
		{
			extern void *gyy_constant___3(void*, void*);
			$$ = gyy_constant___3(make_location(&@$), $1);
		}
;

raw_primary:
	  primary '.' sid
		{
			extern void *gyy_raw_primary___0(void*, void*, void*);
			$$ = gyy_raw_primary___0(make_location(&@$), $1, $3);
		}
	| lambda
		{
			extern void *gyy_raw_primary___1(void*, void*);
			$$ = gyy_raw_primary___1(make_location(&@$), $1);
		}
	| '(' ')'
		{
			extern void *gyy_raw_primary___2(void*);
			$$ = gyy_raw_primary___2(make_location(&@$));
		}
	| primary '(' xexpr_list ')'
		{
			extern void *gyy_raw_primary___3(void*, void*, void*);
			$$ = gyy_raw_primary___3(make_location(&@$), $1, $3);
		}
;

primary:
	  qid
		{
			extern void *gyy_primary___0(void*, void*);
			$$ = gyy_primary___0(make_location(&@$), $1);
		}
	| '(' xexpr ')'
		{
			extern void *gyy_primary___1(void*, void*);
			$$ = gyy_primary___1(make_location(&@$), $2);
		}
	| raw_primary
		{
			extern void *gyy_primary___2(void*, void*);
			$$ = gyy_primary___2(make_location(&@$), $1);
		}
	| constant
		{
			extern void *gyy_primary___3(void*, void*);
			$$ = gyy_primary___3(make_location(&@$), $1);
		}
;

block:
	  '{' stmts '}'
		{
			extern void *gyy_block___0(void*, void*);
			$$ = gyy_block___0(make_location(&@$), $2);
		}
;

func_def:
	  func_header fnc_body
		{
			extern void *gyy_func_def___0(void*, void*, void*);
			$$ = gyy_func_def___0(make_location(&@$), $1, $2);
		}
;

stmt:
	  normal_stmt ';'
		{
			extern void *gyy_stmt___0(void*, void*);
			$$ = gyy_stmt___0(make_location(&@$), $1);
		}
	| block
		{
			extern void *gyy_stmt___1(void*, void*);
			$$ = gyy_stmt___1(make_location(&@$), $1);
		}
	| func_def
		{
			extern void *gyy_stmt___2(void*, void*);
			$$ = gyy_stmt___2(make_location(&@$), $1);
		}
	| loop_stmt
		{
			extern void *gyy_stmt___3(void*, void*);
			$$ = gyy_stmt___3(make_location(&@$), $1);
		}
	| if_stmt
		{
			extern void *gyy_stmt___4(void*, void*);
			$$ = gyy_stmt___4(make_location(&@$), $1);
		}
	| pattern_matching_stmt
		{
			extern void *gyy_stmt___5(void*, void*);
			$$ = gyy_stmt___5(make_location(&@$), $1);
		}
	| try_stmt
		{
			extern void *gyy_stmt___6(void*, void*);
			$$ = gyy_stmt___6(make_location(&@$), $1);
		}
	| error ';'
		{
			extern void *gyy_stmt___7(void*);
			$$ = gyy_stmt___7(make_location(&@$));
		}
;

ne_stmts:
	  stmt ne_stmts
		{
			extern void *gyy_ne_stmts___0(void*, void*, void*);
			$$ = gyy_ne_stmts___0(make_location(&@$), $1, $2);
		}
	| stmt
		{
			extern void *gyy_ne_stmts___1(void*, void*);
			$$ = gyy_ne_stmts___1(make_location(&@$), $1);
		}
;

stmts:
	  stmt stmts
		{
			extern void *gyy_stmts___0(void*, void*, void*);
			$$ = gyy_stmts___0(make_location(&@$), $1, $2);
		}
	| 
		{
			extern void *gyy_stmts___1(void*);
			$$ = gyy_stmts___1(make_location(&last_lex_loc));
		}
;

if_stmt:
	  KW_IF '(' expr ')' stmt
		{
			extern void *gyy_if_stmt___0(void*, void*, void*);
			$$ = gyy_if_stmt___0(make_location(&@$), $3, $5);
		}
	| KW_IF '(' expr ')' stmt KW_ELSE stmt
		{
			extern void *gyy_if_stmt___1(void*, void*, void*, void*);
			$$ = gyy_if_stmt___1(make_location(&@$), $3, $5, $7);
		}
;

single_var_def:
	  id
		{
			extern void *gyy_single_var_def___0(void*, void*);
			$$ = gyy_single_var_def___0(make_location(&@$), $1);
		}
	| id '=' xexpr
		{
			extern void *gyy_single_var_def___1(void*, void*, void*);
			$$ = gyy_single_var_def___1(make_location(&@$), $1, $3);
		}
;

var_def_list:
	  single_var_def ',' var_def_list
		{
			extern void *gyy_var_def_list___0(void*, void*, void*);
			$$ = gyy_var_def_list___0(make_location(&@$), $1, $3);
		}
	| single_var_def
		{
			extern void *gyy_var_def_list___1(void*, void*);
			$$ = gyy_var_def_list___1(make_location(&@$), $1);
		}
;

global_var_def:
	  type_expr var_def_list
		{
			extern void *gyy_global_var_def___0(void*, void*, void*);
			$$ = gyy_global_var_def___0(make_location(&@$), $1, $2);
		}
;

var_def:
	  type_expr var_def_list
		{
			extern void *gyy_var_def___0(void*, void*, void*);
			$$ = gyy_var_def___0(make_location(&@$), $1, $2);
		}
	| '_' var_def_list
		{
			extern void *gyy_var_def___1(void*, void*);
			$$ = gyy_var_def___1(make_location(&@$), $2);
		}
	| KW_DEF var_def_list
		{
			extern void *gyy_var_def___2(void*, void*);
			$$ = gyy_var_def___2(make_location(&@$), $2);
		}
;

for_inc:
	  expr
		{
			extern void *gyy_for_inc___0(void*, void*);
			$$ = gyy_for_inc___0(make_location(&@$), $1);
		}
	| KW_SKIP
		{
			extern void *gyy_for_inc___1(void*);
			$$ = gyy_for_inc___1(make_location(&@$));
		}
	| 
		{
			extern void *gyy_for_inc___2(void*);
			$$ = gyy_for_inc___2(make_location(&last_lex_loc));
		}
;

for_init:
	  for_inc
		{
			extern void *gyy_for_init___0(void*, void*);
			$$ = gyy_for_init___0(make_location(&@$), $1);
		}
	| var_def
		{
			extern void *gyy_for_init___1(void*, void*);
			$$ = gyy_for_init___1(make_location(&@$), $1);
		}
;

for_cond:
	  expr
		{
			extern void *gyy_for_cond___0(void*, void*);
			$$ = gyy_for_cond___0(make_location(&@$), $1);
		}
	| 
		{
			extern void *gyy_for_cond___1(void*);
			$$ = gyy_for_cond___1(make_location(&last_lex_loc));
		}
;

maybe_label:
	  
		{
			extern void *gyy_maybe_label___0(void*);
			$$ = gyy_maybe_label___0(make_location(&last_lex_loc));
		}
	| ID ':'
		{
			extern void *gyy_maybe_label___1(void*, void*);
			$$ = gyy_maybe_label___1(make_location(&@$), $1);
		}
;

loop_stmt:
	  maybe_label KW_WHILE '(' expr ')' stmt
		{
			extern void *gyy_loop_stmt___0(void*, void*, void*, void*);
			$$ = gyy_loop_stmt___0(make_location(&@$), $1, $4, $6);
		}
	| maybe_label KW_DO block KW_WHILE '(' expr ')' ';'
		{
			extern void *gyy_loop_stmt___1(void*, void*, void*, void*);
			$$ = gyy_loop_stmt___1(make_location(&@$), $1, $3, $6);
		}
	| maybe_label KW_FOR '(' for_init ';' for_cond ';' for_inc ')' stmt
		{
			extern void *gyy_loop_stmt___2(void*, void*, void*, void*, void*, void*);
			$$ = gyy_loop_stmt___2(make_location(&@$), $1, $4, $6, $8, $10);
		}
;

maybe_li:
	  ID
		{
			extern void *gyy_maybe_li___0(void*, void*);
			$$ = gyy_maybe_li___0(make_location(&@$), $1);
		}
	| 
		{
			extern void *gyy_maybe_li___1(void*);
			$$ = gyy_maybe_li___1(make_location(&last_lex_loc));
		}
;

normal_stmt:
	  expr
		{
			extern void *gyy_normal_stmt___0(void*, void*);
			$$ = gyy_normal_stmt___0(make_location(&@$), $1);
		}
	| KW_RETURN
		{
			extern void *gyy_normal_stmt___1(void*);
			$$ = gyy_normal_stmt___1(make_location(&@$));
		}
	| KW_RETURN xexpr
		{
			extern void *gyy_normal_stmt___2(void*, void*);
			$$ = gyy_normal_stmt___2(make_location(&@$), $2);
		}
	| KW_SKIP
		{
			extern void *gyy_normal_stmt___3(void*);
			$$ = gyy_normal_stmt___3(make_location(&@$));
		}
	| var_def
		{
			extern void *gyy_normal_stmt___4(void*, void*);
			$$ = gyy_normal_stmt___4(make_location(&@$), $1);
		}
	| KW_RAISE xexpr
		{
			extern void *gyy_normal_stmt___5(void*, void*);
			$$ = gyy_normal_stmt___5(make_location(&@$), $2);
		}
	| KW_BREAK maybe_li
		{
			extern void *gyy_normal_stmt___6(void*, void*);
			$$ = gyy_normal_stmt___6(make_location(&@$), $2);
		}
	| KW_CONTINUE maybe_li
		{
			extern void *gyy_normal_stmt___7(void*, void*);
			$$ = gyy_normal_stmt___7(make_location(&@$), $2);
		}
;

fnc_body:
	  block
		{
			extern void *gyy_fnc_body___0(void*, void*);
			$$ = gyy_fnc_body___0(make_location(&@$), $1);
		}
	| '(' xexpr ')' ';'
		{
			extern void *gyy_fnc_body___1(void*, void*);
			$$ = gyy_fnc_body___1(make_location(&@$), $2);
		}
;

lambda_body:
	  block
		{
			extern void *gyy_lambda_body___0(void*, void*);
			$$ = gyy_lambda_body___0(make_location(&@$), $1);
		}
	| '(' xexpr ')'
		{
			extern void *gyy_lambda_body___1(void*, void*);
			$$ = gyy_lambda_body___1(make_location(&@$), $2);
		}
;

one_case:
	  KW_CASE pattern ':'
		{
			extern void *gyy_one_case___0(void*, void*);
			$$ = gyy_one_case___0(make_location(&@$), $2);
		}
	| KW_CASE pattern KW_IF expr ':'
		{
			extern void *gyy_one_case___1(void*, void*, void*);
			$$ = gyy_one_case___1(make_location(&@$), $2, $4);
		}
;

cases:
	  one_case cases
		{
			extern void *gyy_cases___0(void*, void*, void*);
			$$ = gyy_cases___0(make_location(&@$), $1, $2);
		}
	| one_case
		{
			extern void *gyy_cases___1(void*, void*);
			$$ = gyy_cases___1(make_location(&@$), $1);
		}
;

case_list:
	  cases ne_stmts case_list
		{
			extern void *gyy_case_list___0(void*, void*, void*, void*);
			$$ = gyy_case_list___0(make_location(&@$), $1, $2, $3);
		}
	| cases
		{
			extern void *gyy_case_list___1(void*, void*);
			$$ = gyy_case_list___1(make_location(&@$), $1);
		}
	| 
		{
			extern void *gyy_case_list___2(void*);
			$$ = gyy_case_list___2(make_location(&last_lex_loc));
		}
;

pattern_eq:
	  pattern '=' xexpr
		{
			extern void *gyy_pattern_eq___0(void*, void*, void*);
			$$ = gyy_pattern_eq___0(make_location(&@$), $1, $3);
		}
;

pattern_eq_list:
	  pattern_eq ',' pattern_eq_list
		{
			extern void *gyy_pattern_eq_list___0(void*, void*, void*);
			$$ = gyy_pattern_eq_list___0(make_location(&@$), $1, $3);
		}
	| pattern_eq
		{
			extern void *gyy_pattern_eq_list___1(void*, void*);
			$$ = gyy_pattern_eq_list___1(make_location(&@$), $1);
		}
;

maybe_finally:
	  KW_FINALLY stmt
		{
			extern void *gyy_maybe_finally___0(void*, void*);
			$$ = gyy_maybe_finally___0(make_location(&@$), $2);
		}
	| 
		{
			extern void *gyy_maybe_finally___1(void*);
			$$ = gyy_maybe_finally___1(make_location(&last_lex_loc));
		}
;

maybe_with:
	  KW_WITH '{' case_list '}'
		{
			extern void *gyy_maybe_with___0(void*, void*);
			$$ = gyy_maybe_with___0(make_location(&@$), $3);
		}
	| 
		{
			extern void *gyy_maybe_with___1(void*);
			$$ = gyy_maybe_with___1(make_location(&last_lex_loc));
		}
;

try_stmt:
	  KW_TRY block maybe_with maybe_finally
		{
			extern void *gyy_try_stmt___0(void*, void*, void*, void*);
			$$ = gyy_try_stmt___0(make_location(&@$), $2, $3, $4);
		}
;

pattern_matching_stmt:
	  KW_LET pattern_eq_list KW_IN stmt
		{
			extern void *gyy_pattern_matching_stmt___0(void*, void*, void*);
			$$ = gyy_pattern_matching_stmt___0(make_location(&@$), $2, $4);
		}
	| KW_LET pattern_eq_list ';'
		{
			extern void *gyy_pattern_matching_stmt___1(void*, void*);
			$$ = gyy_pattern_matching_stmt___1(make_location(&@$), $2);
		}
	| KW_SWITCH xexpr '{' case_list '}'
		{
			extern void *gyy_pattern_matching_stmt___2(void*, void*, void*);
			$$ = gyy_pattern_matching_stmt___2(make_location(&@$), $2, $4);
		}
;

sp_entry:
	  sid '=' pattern
		{
			extern void *gyy_sp_entry___0(void*, void*, void*);
			$$ = gyy_sp_entry___0(make_location(&@$), $1, $3);
		}
;

ne_sp_entry_list:
	  sp_entry ',' ne_sp_entry_list
		{
			extern void *gyy_ne_sp_entry_list___0(void*, void*, void*);
			$$ = gyy_ne_sp_entry_list___0(make_location(&@$), $1, $3);
		}
	| sp_entry
		{
			extern void *gyy_ne_sp_entry_list___1(void*, void*);
			$$ = gyy_ne_sp_entry_list___1(make_location(&@$), $1);
		}
;

sp_entry_list:
	  
		{
			extern void *gyy_sp_entry_list___0(void*);
			$$ = gyy_sp_entry_list___0(make_location(&last_lex_loc));
		}
	| ne_sp_entry_list
		{
			extern void *gyy_sp_entry_list___1(void*, void*);
			$$ = gyy_sp_entry_list___1(make_location(&@$), $1);
		}
;

raw_pattern:
	  '_'
		{
			extern void *gyy_raw_pattern___0(void*);
			$$ = gyy_raw_pattern___0(make_location(&@$));
		}
	| pattern_expr
		{
			extern void *gyy_raw_pattern___1(void*, void*);
			$$ = gyy_raw_pattern___1(make_location(&@$), $1);
		}
	| '(' pattern ',' ne_pattern_list ')'
		{
			extern void *gyy_raw_pattern___2(void*, void*, void*);
			$$ = gyy_raw_pattern___2(make_location(&@$), $2, $4);
		}
	| qid '(' pattern_list ')'
		{
			extern void *gyy_raw_pattern___3(void*, void*, void*);
			$$ = gyy_raw_pattern___3(make_location(&@$), $1, $3);
		}
	| pattern KW_AS id
		{
			extern void *gyy_raw_pattern___4(void*, void*, void*);
			$$ = gyy_raw_pattern___4(make_location(&@$), $1, $3);
		}
	| '{' sp_entry_list '}'
		{
			extern void *gyy_raw_pattern___5(void*, void*);
			$$ = gyy_raw_pattern___5(make_location(&@$), $2);
		}
;

pattern:
	  raw_pattern
		{
			extern void *gyy_pattern___0(void*, void*);
			$$ = gyy_pattern___0(make_location(&@$), $1);
		}
	| '[' pattern_list ']'
		{
			extern void *gyy_pattern___1(void*, void*);
			$$ = gyy_pattern___1(make_location(&@$), $2);
		}
;

ne_pattern_list:
	  pattern ',' ne_pattern_list
		{
			extern void *gyy_ne_pattern_list___0(void*, void*, void*);
			$$ = gyy_ne_pattern_list___0(make_location(&@$), $1, $3);
		}
	| pattern
		{
			extern void *gyy_ne_pattern_list___1(void*, void*);
			$$ = gyy_ne_pattern_list___1(make_location(&@$), $1);
		}
;

pattern_list:
	  
		{
			extern void *gyy_pattern_list___0(void*);
			$$ = gyy_pattern_list___0(make_location(&last_lex_loc));
		}
	| ne_pattern_list
		{
			extern void *gyy_pattern_list___1(void*, void*);
			$$ = gyy_pattern_list___1(make_location(&@$), $1);
		}
;

pattern_expr:
	  constant
		{
			extern void *gyy_pattern_expr___0(void*, void*);
			$$ = gyy_pattern_expr___0(make_location(&@$), $1);
		}
	| qid
		{
			extern void *gyy_pattern_expr___1(void*, void*);
			$$ = gyy_pattern_expr___1(make_location(&@$), $1);
		}
;


%%

void *gyy__parse() {
	return (void*)((long)yyparse());
}

/* EOF */
