/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 877 $ $LastChangedDate: 2002-09-07 15:34:12 +0200 (Sat, 07 Sep 2002) $
 *
 * Fifo - first-in/first-out queue.
 */

/** Fifo module provides first-in/first-out mutable queue.  */

/** Type of queues holding values of type ['a].  */
type <'a>t;

/** Return freshly created empty queue.  */
<'a>t create();

/** Return [true] iff [q] holds no elements.  */
bool empty(<'a>t q);

/** Append [a] at the end of [q].  */
void put(<'a>t q, 'a a);

/** Return first element of [q]. Element is then removed from queue.  
    Raise [Invalid_argument] if [q] is empty.  */
'a get(<'a>t q);

/** Return first element of [q]. Queue is left unchanged.  Raise 
    [Invalid_argument] if [q] is empty.  */
'a peek(<'a>t);
