/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 900 $ $LastChangedDate: 2002-09-08 01:04:18 +0200 (Sun, 08 Sep 2002) $
 *
 * Standard library for Gont, Unitype module implementation.
 */

open Unitype;

int i(char c)
{
    return Hacks::cast(c);
}

bool is_ascii(char c)
{
    return i(c) < 128;
}

bool is_7_bit(char c)
{
    return i(c) < 128;
}

bool is_8_bit(char c)
{
    return i(c) < 256;
}

bool is_16_bit(char c)
{
    return i(c) < (256 * 256);
}

bool is_ascii_uppercase(char c)
{
    return is_ascii(c) && is_uppercase(c);
}

bool is_ascii_lowercase(char c)
{
    return is_ascii(c) && is_lowercase(c);
}

bool is_ascii_letter(char c)
{
    return is_ascii(c) && is_letter(c);
}

bool is_ascii_number(char c)
{
    return is_ascii(c) && is_number(c);
}

bool is_ascii_alnum(char c)
{
    return is_ascii(c) && is_alnum(c);
}

bool is_ascii_xnumber(char c)
{
    return is_ascii_number(c) || 
           (i(c) >= i('a') && i(c) <= i('f')) ||
           (i(c) >= i('A') && i(c) <= i('F'));
}

bool is_ascii_blank(char c)
{
    return i(c) == i(' ') || i(c) == i('\t');
}

// vim:sts=4:sw=4
